"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unflattenRemoveArrayStateUpdate = exports.unflattenArrayStateUpdate = exports.unflatten = void 0;

var _getValue = _interopRequireDefault(require("./get-value"));

var _flat = require("flat");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var unflatten = function unflatten(path, value) {
  var object;

  if (Array.isArray(path)) {
    object = path.reduce(function (acc, path, index) {
      if (Array.isArray(value)) {
        acc[path] = value[index];
      } else {
        acc[path] = value;
      }

      return acc;
    }, {});
  } else {
    object = _defineProperty({}, "".concat(path), value);
  }

  return (0, _flat.unflatten)(object, {
    object: true
  });
};

exports.unflatten = unflatten;

var unflattenArrayStateUpdate = function unflattenArrayStateUpdate(state, path, value) {
  var pathValue = (0, _getValue.default)(state, path);

  if (Array.isArray(pathValue)) {
    return unflatten("".concat(path, ".$push"), [value]);
  } else {
    return unflatten("".concat(path, ".$set"), [value]);
  }
};

exports.unflattenArrayStateUpdate = unflattenArrayStateUpdate;

var unflattenRemoveArrayStateUpdate = function unflattenRemoveArrayStateUpdate(path) {
  if (!Array.isArray(path)) {
    path = [path];
  }

  var _path$reduce = path.reduce(function (acc, path) {
    var pathSegments = path.split('.');
    var index = parseInt(pathSegments.pop(), 10);
    var splice = "".concat(pathSegments.join('.'), ".$splice");
    var pathIndex = acc.paths.indexOf(splice);

    if (pathIndex === -1) {
      acc.paths.push(splice);
      acc.removals.push([[index, 1]]);
    } else {
      acc.removals[pathIndex].push([index, 1]);
    }

    return acc;
  }, {
    paths: [],
    removals: []
  }),
      paths = _path$reduce.paths,
      removals = _path$reduce.removals;

  return unflatten(paths, removals);
}; // export const unflattenRemoveArrayStateUpdate = (path: string): Object => {
//   const pathSegments: Array<any> = path.split('.')
//   const index: number = parseInt(pathSegments.pop(), 10)
//   return unflatten(`${pathSegments.join('.')}.$splice`, [[index, 1]])
// }


exports.unflattenRemoveArrayStateUpdate = unflattenRemoveArrayStateUpdate;